WeakReference (Java Platform SE 8 )
Keywords: java.lang.ref.WeakReference class
Date: 2026-03-29

compact1, compact2, compact3
java.lang.ref

## Class WeakReference<T>

- java.lang.Object
- - java.lang.ref.Reference<T>
  - - java.lang.ref.WeakReference<T>

-     public class WeakReference<T>
      extends Reference<T>

  Weak reference objects, which do not prevent their referents from being made finalizable, finalized, and then reclaimed. Weak references are most often used to implement canonicalizing mappings.

  Suppose that the garbage collector determines at a certain point in time that an object is weakly reachable. At that time it will atomically clear all weak references to that object and all weak references to any other weakly-reachable objects from which that object is reachable through a chain of strong and soft references. At the same time it will declare all of the formerly weakly-reachable objects to be finalizable. At the same time or at some later time it will enqueue those newly-cleared weak references that are registered with reference queues.

  Since:
    1.2

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `WeakReference(T referent)` Creates a new weak reference that refers to the given object.
    `WeakReference(T referent, ReferenceQueue<? super T> q)` Creates a new weak reference that refers to the given object and is registered with the given queue.

  - ### Method Summary

    - ### Methods inherited from class java.lang.ref.Reference

      `clear, clone, enqueue, get, isEnqueued`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### WeakReference

          public WeakReference(T referent)

      Creates a new weak reference that refers to the given object. The new reference is not registered with any queue.
      Parameters:
        `referent` - object the new weak reference will refer to

    - #### WeakReference

          public WeakReference(T referent,
                               ReferenceQueue<? super T> q)

      Creates a new weak reference that refers to the given object and is registered with the given queue.
      Parameters:
        `referent` - object the new weak reference will refer to
        `q` - the queue with which the reference is to be registered, or `null` if registration is not required

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.